Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_advect_em.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_advect_em.F	(revision 195)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_advect_em.F	(revision 196)
@@ -5831,14 +5992,16 @@
 !--  modify loop bounds if open or specified
 
-      IF(degrade_xs) i_start = its
-      IF(degrade_xe) i_end   = MIN(ite,ide-1)
+!      IF(degrade_xs) i_start = MAX(its-1,ids-1)
+!      IF(degrade_xe) i_end   = MIN(ite+1,ide-2)
+      IF(degrade_xs) i_start = MAX(its-1,ids)
+      IF(degrade_xe) i_end   = MIN(ite+1,ide-1)
 
       IF(degrade_ys) then
-        j_start = MAX(jts,jds+1)
+        j_start = MAX(jts-1,jds+1)
         j_start_f = jds+3
       ENDIF
 
       IF(degrade_ye) then
-        j_end = MIN(jte,jde-2)
+        j_end = MIN(jte+1,jde-2)
         j_end_f = jde-3
       ENDIF
@@ -5960,14 +6123,16 @@
 !--  modify loop bounds for open and specified b.c
 
-      IF(degrade_ys) j_start = jts
-      IF(degrade_ye) j_end   = MIN(jte,jde-1)
+!      IF(degrade_ys) j_start = MAX(jts-1,jds+1)
+!      IF(degrade_ye) j_end   = MIN(jte+1,jde-2)
+      IF(degrade_ys) j_start = MAX(jts-1,jds)
+      IF(degrade_ye) j_end   = MIN(jte+1,jde-1)
 
       IF(degrade_xs) then
-        i_start = MAX(ids+1,its)
-        i_start_f = i_start+2
+        i_start = MAX(ids+1,its-1)
+        i_start_f = ids+3
       ENDIF
 
       IF(degrade_xe) then
-        i_end = MIN(ide-2,ite)
+        i_end = MIN(ide-2,ite+1)
         i_end_f = ide-3
       ENDIF
@@ -6001,67 +6166,68 @@
         IF( degrade_xs ) THEN
 
-          IF( i_start == ids+1 ) THEN ! second order flux next to the boundary
-            i = ids+1
-            DO k=kts,ktf
-
-              dx = 2./(msft(i,j)+msft(i-1,j))/rdx
-              mu = 0.5*(mut(i,j)+mut(i-1,j))
-              vel = ru(i,k,j)/mu
-              cr = vel*dt/dx
-              fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
-
-              fqx(i,k,j) = 0.5*(ru(i,k,j)) &
-                     *(field(i,k,j)+field(i-1,k,j))
-
-              fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
-
-            ENDDO
-          ENDIF
-
-          i = ids+2
-          DO k=kts,ktf
-            dx = 2./(msft(i,j)+msft(i-1,j))/rdx
-            mu = 0.5*(mut(i,j)+mut(i-1,j))
-            vel = ru(i,k,j)
-            cr = vel*dt/dx/mu
-            fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
-            fqx( i,k,j ) = vel*flux3( field(i-2,k,j), field(i-1,k,j),  &
-                                          field(i  ,k,j), field(i+1,k,j),  &
-                                          vel                     )
-            fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
-
-          ENDDO
-
-        ENDIF
-
-        IF( degrade_xe ) THEN
-
-          IF( i_end == ide-2 ) THEN ! second order flux next to the boundary
-            i = ide-1
-            DO k=kts,ktf
-              dx = 2./(msft(i,j)+msft(i-1,j))/rdx
-              mu = 0.5*(mut(i,j)+mut(i-1,j))
-              vel = ru(i,k,j)
-              cr = vel*dt/dx/mu
-              fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
-              fqx(i,k,j) = 0.5*(ru(i,k,j))      &
-                     *(field(i,k,j)+field(i-1,k,j))
-              fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
-
-            ENDDO
-          ENDIF
-
-          i = ide-2
-          DO k=kts,ktf
-
-            dx = 2./(msft(i,j)+msft(i-1,j))/rdx
-            mu = 0.5*(mut(i,j)+mut(i-1,j))
-            vel = ru(i,k,j)
-            cr = vel*dt/dx/mu
-            fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
-            fqx( i,k,j ) = vel*flux3( field(i-2,k,j), field(i-1,k,j),  &
+          DO i=i_start,i_start_f-1
+
+            IF(i == ids+1) THEN ! second order
+              DO k=kts,ktf
+                dx = 2./(msft(i,j)+msft(i-1,j))/rdx
+                mu = 0.5*(mut(i,j)+mut(i-1,j))
+                vel = ru(i,k,j)/mu
+                cr = vel*dt/dx
+                fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
+                fqx(i,k,j) = 0.5*(ru(i,k,j)) &
+                       *(field(i,k,j)+field(i-1,k,j))
+                fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
+              ENDDO
+            ENDIF
+
+            IF(i == ids+2) THEN  ! third order
+              DO k=kts,ktf
+                dx = 2./(msft(i,j)+msft(i-1,j))/rdx
+                mu = 0.5*(mut(i,j)+mut(i-1,j))
+                vel = ru(i,k,j)
+                cr = vel*dt/dx/mu
+                fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
+                fqx( i,k,j ) = vel*flux3( field(i-2,k,j), field(i-1,k,j),  &
                                           field(i  ,k,j), field(i+1,k,j),  &
                                           vel                             )
-            fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
+                fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
+              ENDDO
+            ENDIF
+
+          ENDDO
+
+        ENDIF
+
+        IF( degrade_xe ) THEN
+
+          DO i = i_end_f+1, i_end+1
+
+            IF( i == ide-1 ) THEN ! second order flux next to the boundary
+              DO k=kts,ktf
+                dx = 2./(msft(i,j)+msft(i-1,j))/rdx
+                mu = 0.5*(mut(i,j)+mut(i-1,j))
+                vel = ru(i,k,j)
+                cr = vel*dt/dx/mu
+                fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
+                fqx(i,k,j) = 0.5*(ru(i,k,j))      &
+                       *(field(i,k,j)+field(i-1,k,j))
+                fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
+              ENDDO
+            ENDIF
+
+
+            IF( i == ide-2 ) THEN ! third order flux one in from the boundary
+              DO k=kts,ktf
+                dx = 2./(msft(i,j)+msft(i-1,j))/rdx
+                mu = 0.5*(mut(i,j)+mut(i-1,j))
+                vel = ru(i,k,j)
+                cr = vel*dt/dx/mu
+                fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
+                fqx( i,k,j ) = vel*flux3( field(i-2,k,j), field(i-1,k,j),  &
+                                          field(i  ,k,j), field(i+1,k,j),  &
+                                          vel                             )
+                fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
+              ENDDO
+            ENDIF
 
           ENDDO
@@ -6275,14 +6441,14 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+1)                ) degrade_xs = .false.
+       (its > ids+2)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
-       (ite < ide-2)                ) degrade_xe = .false.
+       (ite < ide-1)                ) degrade_xe = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+1)                ) degrade_ys = .false.
+       (jts > jds+2)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-2)                ) degrade_ye = .false.
+       (jte < jde-1)                ) degrade_ye = .false.
 
 !--------------- y - advection first
@@ -6475,14 +6641,14 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids)                ) degrade_xs = .false.
+       (its > ids+1)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
-       (ite < ide-1)                ) degrade_xe = .false.
+       (ite < ide-2)                ) degrade_xe = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds)                ) degrade_ys = .false.
+       (jts > jds+1)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-1)                ) degrade_ye = .false.
+       (jte < jde-2)                ) degrade_ye = .false.
 
 !--  y flux compute; these bounds are for periodic and sym b.c.
@@ -6530,7 +6696,7 @@
             cr = vel*dt/dx/mu
             fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
-            fqx( i,k,j ) = vel*flux3( field(i-2,k,j), field(i-1,k,j),  &
-                                          field(i  ,k,j), field(i+1,k,j),  &
-                                          vel                             )
+            fqx( i,k,j ) = 0.5*ru(i,k,j)*          &
+                  (field(i,k,j)+field(i-1,k,j))
+
             fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
         ENDDO
@@ -6538,5 +6704,5 @@
       ENDDO
 
-!--- end of 3nd order horizontal flux calculation
+!--- end of 2nd order horizontal flux calculation
 
    ELSE
@@ -6633,8 +6799,8 @@
 !-- loop bounds for open or specified conditions
 
-    IF(degrade_xs) i_start = its
-    IF(degrade_xe) i_end   = MIN(ite,ide-1)
-    IF(degrade_ys) j_start = jts
-    IF(degrade_ye) j_end   = MIN(jte,jde-1)
+    IF(degrade_xs) i_start = MAX(its-1,ids)
+    IF(degrade_xe) i_end   = MIN(ite+1,ide-1)
+    IF(degrade_ys) j_start = MAX(jts-1,jds)
+    IF(degrade_ye) j_end   = MIN(jte+1,jde-1)
 
     vert_order_test : IF (vert_order == 6) THEN    
@@ -6931,27 +7097,27 @@
 !-- loop bounds for open or specified conditions
 
-   IF(degrade_xs) i_start = its
-   IF(degrade_xe) i_end   = MIN(ite,ide-1)
-   IF(degrade_ys) j_start = jts
-   IF(degrade_ye) j_end   = MIN(jte,jde-1)
+   IF(degrade_xs) i_start = MAX(its-1,ids)
+   IF(degrade_xe) i_end   = MIN(ite+1,ide-1)
+   IF(degrade_ys) j_start = MAX(jts-1,jds)
+   IF(degrade_ye) j_end   = MIN(jte+1,jde-1)
 
    IF(config_flags%specified .or. config_flags%nested) THEN
-     IF (degrade_xs) i_start = MAX(its,ids+1)
-     IF (degrade_xe) i_end   = MIN(ite,ide-2)
-     IF (degrade_ys) j_start = MAX(jts,jds+1)
-     IF (degrade_ye) j_end   = MIN(jte,jde-2)
+     IF (degrade_xs) i_start = MAX(its-1,ids+1)
+     IF (degrade_xe) i_end   = MIN(ite+1,ide-2)
+     IF (degrade_ys) j_start = MAX(jts-1,jds+1)
+     IF (degrade_ye) j_end   = MIN(jte+1,jde-2)
    END IF
 
    IF(config_flags%open_xs) THEN
-     IF (degrade_xs) i_start = MAX(its,ids+1)
+     IF (degrade_xs) i_start = MAX(its-1,ids+1)
    END IF
    IF(config_flags%open_xe) THEN
-     IF (degrade_xe) i_end   = MIN(ite,ide-2)
+     IF (degrade_xe) i_end   = MIN(ite+1,ide-2)
    END IF
    IF(config_flags%open_ys) THEN
-     IF (degrade_ys) j_start = MAX(jts,jds+1)
+     IF (degrade_ys) j_start = MAX(jts-1,jds+1)
    END IF
    IF(config_flags%open_ye) THEN
-     IF (degrade_ye) j_end   = MIN(jte,jde-2)
+     IF (degrade_ye) j_end   = MIN(jte+1,jde-2)
    END IF
 
@@ -6962,14 +7128,16 @@
    DO i=i_start, i_end
 
-     ph_low = (mub(i,j)+mu_old(i,j))*field_old(i,k,j)                   &
-                - dt*( msft(i,j)*( rdx*(fqxl(i+1,k,j)-fqxl(i,k,j))      &
-                                  +rdy*(fqyl(i,k,j+1)-fqyl(i,k,j)) )    &
-                              +rdzw(k)*(fqzl(i,k+1,j)-fqzl(i,k,j))   )  
-
-     flux_out = dt*(msft(i,j)*( rdx*(  max(0.,fqx (i+1,k,j))      &
+     ph_low = (mub(i,j)+mu_old(i,j))*field_old(i,k,j)        &
+                - dt*( msft(i,j)*(                           & 
+                       rdx*(fqxl(i+1,k,j)-fqxl(i,k,j)) +     &
+                       rdy*(fqyl(i,k,j+1)-fqyl(i,k,j))  )    &
+                      +         rdzw(k)*(fqzl(i,k+1,j)-fqzl(i,k,j)) )
+
+     flux_out = dt*(  msft(i,j)             *(                    &
+                                rdx*(  max(0.,fqx (i+1,k,j))      &
                                       -min(0.,fqx (i  ,k,j)) )    &
                                +rdy*(  max(0.,fqy (i,k,j+1))      &
                                       -min(0.,fqy (i,k,j  )) ) )  &
-                           +rdzw(k)*(  min(0.,fqz (i,k+1,j))      &
+                +           rdzw(k)*(  min(0.,fqz (i,k+1,j))      &
                                       -max(0.,fqz (i,k  ,j)) )   )
 
@@ -7015,6 +7183,6 @@
 ! x flux divergence
 !
-  IF(degrade_xs) i_start = i_start + 1
-  IF(degrade_xe) i_end   = i_end   - 1
+  IF(degrade_xs) i_start = MAX(its,ids+1)
+  IF(degrade_xe) i_end   = MIN(ite,ide-2)
 
   DO j = j_start, j_end
@@ -7023,5 +7191,5 @@
 
      tendency (i,k,j) = tendency(i,k,j)                           &
-                - msft(i,j)*( rdx*( fqx (i+1,k,j)-fqx (i,k,j)     &
+               - msft(i,j)*( rdx*( fqx (i+1,k,j)-fqx (i,k,j)     &
                                    +fqxl(i+1,k,j)-fqxl(i,k,j))   )
 
@@ -7034,6 +7202,6 @@
   i_start = its
   i_end   = MIN(ite,ide-1)
-  IF(degrade_ys) j_start = j_start + 1
-  IF(degrade_ye) j_end   = j_end   - 1
+  IF(degrade_ys) j_start = MAX(jts,jds+1)
+  IF(degrade_ye) j_end   = MIN(jte,jde-2)
 
   DO j = j_start, j_end
@@ -7042,5 +7210,5 @@
 
      tendency (i,k,j) = tendency(i,k,j)                           &
-                - msft(i,j)*( rdy*( fqy (i,k,j+1)-fqy (i,k,j)     &
+               - msft(i,j)*( rdy*( fqy (i,k,j+1)-fqy (i,k,j)     &
                                    +fqyl(i,k,j+1)-fqyl(i,k,j))   )
 
